#define _SECURE_SCL 0

#include "AI_L3_Extreme.h"

// BoostŕKvȋ@\Kvcpp̒ŃCN[h

// gł
#include <boost/random.hpp>

// foreachgł
#include <boost/foreach.hpp>
// 啶̖OforeachƂĈ܂
#define foreach BOOST_FOREACH
// definěɂ;tȂI

// boost::tȂĂ悤using܂
using namespace boost;


AI_L3_Extreme::AI_L3_Extreme(StoneColor argColor) : AIBase(argColor),
	gen(static_cast<unsigned long>(time(0)))
{
	// ǉoŕKvȏΎĂ
}

AI_L3_Extreme::~AI_L3_Extreme(void)
{
}

CellPosition AI_L3_Extreme::SelectRandomFromList(list<CellPosition> &argList)
{
	uniform_smallint<> dst(1, argList.size());
	variate_generator< mt19937&, uniform_smallint<> > rand(gen, dst);
	int count = 1, select = rand();
	foreach(CellPosition &pos, argList) {
		if(count == select) {
			return pos;
		}
		++count;
	}
	fl_alert("rand() error!");
	return argList.front();
}

double AI_L3_Extreme::CalcWinRate(int num, CellPosition &argPos)
{
	BoardInfo			startInfo = nowInfo;
	list<CellPosition>	tmpList;
	int					winCount = 0;

	for(int i = 0; i < num; ++i) {
		BoardInfo tmpInfo = startInfo;
		StoneColor tmpColor = myColor;

		tmpInfo.putTest(tmpColor, argPos);

		while(true) {
			tmpColor = Stone::opposite(tmpColor);
			if(tmpInfo.getPuttableList(tmpColor, &tmpList) == false) {
				tmpColor = Stone::opposite(tmpColor);
				if(tmpInfo.getPuttableList(tmpColor, &tmpList) == false) {
					int black, white;
					if(myColor == tmpInfo.judge(&black, &white)) {
						++winCount;
					}
					break;
				} else {
					tmpInfo.putTest(tmpColor, SelectRandomFromList(tmpList));
				}
			} else {
				tmpInfo.putTest(tmpColor, SelectRandomFromList(tmpList));
			}
		}
	}

	return (double)winCount/(double)num;
}

// AI̎֐
CellPosition AI_L3_Extreme::getHand(void)
{
	// ʂƂĕԂWloĂϐ
	CellPosition	choicePos;
	bool			discovered = false;
	double			maxRate = 0.0;

	foreach(CellPosition &pos, puttingList) {
		double rate = CalcWinRate(1000, pos);
		cout << "(" << pos.x <<"," << pos.y << ")ɑłꍇ̏:" << rate << endl;
		if(rate > maxRate) {
			choicePos = pos;
			maxRate = rate;
			discovered = true;
		}
	}

	if(!discovered) {
		return SelectRandomFromList(puttingList);
	}

	// Ō͔zł̍Wl̂܂ܕԂĉ
	return choicePos;
}
