#include "AI_L2_Advanced.h"

// BoostŕKvȋ@\Kvcpp̒ŃCN[h

// gł
//#include <boost/random.hpp>

// foreachgł
#include <boost/foreach.hpp>
// 啶̖OforeachƂĈ܂
#define foreach BOOST_FOREACH
// definěɂ;tȂI

// XR[v^C}[
#include <boost/progress.hpp>

// boost::tȂĂ悤using܂
using namespace boost;


AI_L2_Advanced::AI_L2_Advanced(StoneColor argColor) : AIBase(argColor)
{
	// ǉoŕKvȏΎĂ
}

AI_L2_Advanced::~AI_L2_Advanced(void)
{
}

CellPosition AI_L2_Advanced::SelectRandomFromList(list<CellPosition> &argList)
{
	uniform_smallint<> dst(1, argList.size());
	variate_generator< mt19937&, uniform_smallint<> > rand(gen, dst);
	int count = 1, select = rand();
	foreach(CellPosition &pos, argList) {
		if(count == select) {
			return pos;
		}
		++count;
	}
	fl_alert("rand() error!");
	return argList.front();
}

bool AI_L2_Advanced::IsCorner(CellPosition &pos)
{
	return (
		(pos.x == 0 && pos.y == 0) || (pos.x == 0 && pos.y == 7) ||
		(pos.x == 7 && pos.y == 0) || (pos.x == 7 && pos.y == 7)
	);
}

bool AI_L2_Advanced::IsOK(CellPosition &pos)
{
	return (
		(pos.x == 0 && pos.y >= 2 && pos.y <= 5) ||
		(pos.x == 7 && pos.y >= 2 && pos.y <= 5) ||
		(pos.y == 0 && pos.x >= 2 && pos.x <= 5) ||
		(pos.y == 7 && pos.x >= 2 && pos.x <= 5)
	);
}

bool AI_L2_Advanced::IsNG(CellPosition &pos)
{
	return ( !IsCorner(pos) && (
		(pos.x <= 1 && pos.y <= 1) || (pos.x >= 6 && pos.y >= 6) ||
		(pos.x <= 1 && pos.y >= 6) || (pos.x >= 6 && pos.y <= 1)
		)
	);
}

int AI_L2_Advanced::Evaluate(BoardInfo info, CellPosition &argPos, int depth)
{
	// T[x炷(ċAp)
	--depth;

	list<CellPosition>	tmpList;
	int eval = 0;

	info.putTest(myColor, argPos);

	if(info.getPuttableList(Stone::opposite(myColor), &tmpList) == false) {
		// 肩łĂꏊD͍]
		eval += 10000;
	} else {
		// ̎萔̑̓}CiXvf
		eval -= (int)tmpList.size();
		// ̎uĂ݂
		BoardInfo			tmpInfo = info;
		list<CellPosition>	tmpList2;
		CellPosition		tmpChoice;
		int					tmpEval = 9999;
		// Ԃ̑IAȎI
		foreach(CellPosition &pos, tmpList) {
			if(IsCorner(pos)) {
				tmpChoice = pos;
				tmpEval = -10000;
				break;
			}
			info = tmpInfo;
			info.putTest(Stone::opposite(myColor), pos);
			if(info.getPuttableList(myColor, &tmpList2)) {
				if(tmpEval > (int)tmpList2.size()) {
					tmpChoice = pos;
					tmpEval = (int)tmpList2.size();
				}
			} else {
				tmpChoice = pos;
				tmpEval = 0;
			}
		}
		eval += tmpEval;
		// ȎuĂ݂
		info = tmpInfo;
		info.putTest(Stone::opposite(myColor), tmpChoice);
		if(info.getPuttableList(Stone::opposite(myColor), &tmpList2)) {
			// ̎萔̑̓vXvf
			eval += (int)tmpList2.size();
			// ̎uĂ݂
			BoardInfo			tmpInfo2 = info;
			list<CellPosition>	tmpList3;
			CellPosition		tmpChoice2;
			int					tmpEval2 = 9999;
			foreach(CellPosition &pos, tmpList2) {
				if(IsCorner(pos)) {
					tmpChoice2 = pos;
					tmpEval = 0;
					eval += 10000;
					break;
				}
				info = tmpInfo2;
				info.putTest(myColor, pos);
				if(info.getPuttableList(Stone::opposite(myColor), &tmpList3)) {
					if(tmpEval2 > (int)tmpList3.size()) {
						tmpChoice2 = pos;
						tmpEval2 = (int)tmpList3.size();
					}
				}
			}
			eval -= tmpEval2;
			if(depth > 0) {
				eval += Evaluate(info, tmpChoice2, depth);
			}
		} else {
			eval -= 10000;
		}
	}

	return eval; 
}

// AI̎֐
CellPosition AI_L2_Advanced::getHand(void)
{
	// ʂƂĕԂWloĂϐ
	CellPosition	choicePos;

	// pȂ
	// uƂŊpꂻȏꏊɂ͒uȂ
	// ȊO̓_

	list<CellPosition> okList, ngList, randList;

	// łĂO[v
	foreach(CellPosition &pos, puttingList) {
		if(IsCorner(pos)) {
			// pȂⓚpŎ
			return pos;
		} else if(IsOK(pos)) {
			// pɐڂĂȂ[OK
			okList.push_back(pos);
		} else if(IsNG(pos)) {
			// pɐڂĂZNG
			ngList.push_back(pos);
		} else {
			// ȊO̓_
			randList.push_back(pos);
		}
	}

	bool				first = true;
	int					maxEval;
	int					depth = 4;
	list<CellPosition>	*p_list = NULL;

	if(okList.size() >= 1) {
		p_list = &okList;
	} else if(randList.size() >= 1) {
		p_list = &randList;
	} else {
		p_list = &ngList;
	}
	foreach(CellPosition &pos, *p_list) {
		int eval = Evaluate(nowInfo, pos, depth);
		cout << "(" << pos.x <<"," << pos.y << ")ɑłꍇ̕]l:" << eval << endl;
		if(first == true || eval > maxEval) {
			choicePos = pos;
			maxEval = eval;
			first = false;
		}
	}

	// Ō͔zł̍Wl̂܂ܕԂĉ
	return choicePos;
}
