#define _SECURE_SCL 0

#include "AI_L4_Master.h"

// BoostŕKvȋ@\Kvcpp̒ŃCN[h

// gł
//#include <boost/random.hpp>

// foreachgł
#include <boost/foreach.hpp>
// 啶̖OforeachƂĈ܂
#define foreach BOOST_FOREACH
// definěɂ;tȂI

// Xbh
#include <boost/thread.hpp>

// boost::tȂĂ悤using܂
using namespace boost;

static boost::mutex	rand_lock;


AI_L4_Master::AI_L4_Master(StoneColor argColor) : AIBase(argColor)
{
	// V[h̏
	gen.seed(static_cast<unsigned long>(time(0)));

	return;
}

AI_L4_Master::~AI_L4_Master(void)
{
}

CellPosition AI_L4_Master::SelectRandomFromList(list<CellPosition> &argList, mt19937 &gen) const
{
	int count = 1, select;
	uniform_smallint<> dst(1, argList.size());
	{
		rand_lock.lock();
		variate_generator< mt19937&, uniform_smallint<> > rand(gen, dst);
		select = rand();
		rand_lock.unlock();
	}
	foreach(CellPosition &pos, argList) {
		if(count == select) {
			return pos;
		}
		++count;
	}
	fl_alert("rand() error!");
	return argList.front();
}

bool AI_L4_Master::IsWin(StoneColor tmpColor, BoardInfo tmpInfo, CellPosition argPos, mt19937 &gen) const
{
	list<CellPosition>	tmpList;
	bool				retVal = false;

	tmpInfo.putTest(tmpColor, argPos);

	while(true) {
		tmpColor = Stone::opposite(tmpColor);
		if(tmpInfo.getPuttableList(tmpColor, &tmpList) == false) {
			tmpColor = Stone::opposite(tmpColor);
			if(tmpInfo.getPuttableList(tmpColor, &tmpList) == false) {
				int black, white;
				if(myColor == tmpInfo.judge(&black, &white)) {
					retVal = true;
				}
				break;
			} else {
				tmpInfo.putTest(tmpColor, SelectRandomFromList(tmpList, gen));
			}
		} else {
			tmpInfo.putTest(tmpColor, SelectRandomFromList(tmpList, gen));
		}
	}

	return retVal;
}

void AI_L4_Master::MT_Simulate(int *result, int num ,
	StoneColor color, BoardInfo info, CellPosition pos, mt19937 &gen) const
{
	*result = 0;
	for(int i = 0; i < num; ++i) {
		*result += IsWin(myColor, nowInfo, pos, gen) ? 1 : 0;
	}

	return;
}

double AI_L4_Master::CalcWinRate(int num, CellPosition &argPos)
{
	CellPosition pos = argPos;
	int count[THREAD_NUM];
	boost::thread	*thr[THREAD_NUM];

	for(int i = 0; i < THREAD_NUM; ++i) {
		thr[i] = new boost::thread(&AI_L4_Master::MT_Simulate, this,
			&count[i], num/THREAD_NUM, myColor, nowInfo, pos, gen);
	}

	for(int i = 0; i < THREAD_NUM; ++i) {
		thr[i]->join();
		delete thr[i];
	}

	int result = 0;
	for(int i = 0; i < THREAD_NUM; ++i) {
		result += count[i];
	}

	return (double)result/(double)num;
}

// AI̎֐
CellPosition AI_L4_Master::getHand(void)
{
	// ʂƂĕԂWloĂϐ
	CellPosition	choicePos;
	bool			discovered = false;
	double			maxRate = 0.0;

	foreach(CellPosition &pos, puttingList) {
		double rate = CalcWinRate(4800, pos);
		cout << "(" << pos.x <<"," << pos.y << ")ɑłꍇ̏:" << rate << endl;
		if(rate > maxRate) {
			choicePos = pos;
			maxRate = rate;
			discovered = true;
		}
	}

	if(!discovered) {
		return SelectRandomFromList(puttingList, gen);
	}

	// Ō͔zł̍Wl̂܂ܕԂĉ
	return choicePos;
}
