#ifndef __AI_L4_Master_H__
#define __AI_L4_Master_H__

#include "AIBase.h"
#include <boost/random.hpp>

// ʓ|ȏꍇ͂̃NX̒gėpĂ\܂
class AI_L4_Master : public AIBase {
public:
	// FŎ󂯎RXgN^͕K쐬Ă
	AI_L4_Master(StoneColor color);
	virtual ~AI_L4_Master(void);

	// genHand()͕̎K{ł
	CellPosition getHand(void);
protected:
	CellPosition	SelectRandomFromList(list<CellPosition> &, boost::mt19937 &) const;
	double			CalcWinRate(int, CellPosition &);
	bool			IsWin(StoneColor, BoardInfo, CellPosition, boost::mt19937 &) const;

	void			MT_Simulate(int *, int, StoneColor, BoardInfo, CellPosition, boost::mt19937 &) const;

	static const int	THREAD_NUM = 4;
	boost::mt19937		gen;

};

#endif //__AI_L4_Master_H__
