#ifndef __BOARD_H__
#define __BOARD_H__

#include <FK/FK.h>
#include "Stone.h"
#include "BoardInfo.h"


// [6/19]NbŇʂ`
enum ClickResult {
	CR_FAILED = -3,		// uȂ
	CR_OUT_RANGE = -2,	// ՖʊO
	CR_SUCCESS = -1		// u
	// 0ȏF̗vfԍ̐΂uĂ
};

// IZ̔Ֆʂ\NX
class Board {
public:
	// RXgN^ƃfXgN^
	Board(void);
	virtual ~Board(void);
	
	// Ֆʂ`鏈
	void	setupBoard(void);
	// \E\֐ĊO琧ł悤
	void	entry(fk_Scene *scene);
	void	remove(fk_Scene *scene);

	// [6/19]t[̍XV(΂̍XVĂяop)
	void	update(StoneColor nowTurn);
	// ЂԂĂ΂邩ǂ̖₢킹
	bool	isAnimate(void);
	
	// NbNꂽʒu1ɓnA␳ʂ2ɕԂB
	// [6/19]̎Ԃ̐F3ɓnB4ɁAۂɂЂԂȂtrueA`FbNȂfalsenB
	// ܂ԒlƂāAɒuȂ-1A͈͊OȂ-2A
	// ɐ΂uĂꍇ̗͂vfԍԂB
	int		checkCell(const fk_Vector &pos, fk_Vector *adjustPos, StoneColor color, bool flagRev);

	// BoardInfoɊۓ
	// [7/3]u邩ǂ𔻒肷֐
	bool	isPuttable(StoneColor nowTurn);
	// [7/3]s֐
	StoneColor	judge(int *blackNum, int *whiteNum) const;
	
	// [6/19z]΂w肵ꏊɐ鏈(F𖾎IɎw肷悤ɕύX)
	int		makeStone(const fk_Vector &pos, StoneColor color, fk_Scene *scene);
	// [6/19z]΂֐
	void	clearStone(fk_Scene *scene);

	// [6/19]Ώ̏o
	void	saveState(ofstream &out_file);	
	// [6/19]Ώ̓ǂݍ
	bool	loadState(ifstream &in_file, fk_Scene *scene);

	BoardInfo& getInfo(void);

protected:
	// Ֆʕ\po
	fk_Block		block;
	fk_Model		blockModel;
	fk_Line			grid;
	fk_Model		gridModel;
	// [6/19]΂Ɏ邱Ƃɂ
	vector<Stone *>	stoneArray;

	// [7/3]2zƂɂ܂֐NXėp
	BoardInfo		info;
};

// XgCe[^ŎQƂ(Ce[^̌^typedefĎgƕ֗)
typedef list<CellPosition>::iterator	ListIte;


#endif //__BOARD_H__
